import { useEffect, useMemo } from 'react';
import { useStableCallback } from './use-stable-callback';
import { debounce } from 'lodash';
export function useResize(_ref, deps) {
  var el = _ref.el,
    _ref$onResize = _ref.onResize,
    onResize = _ref$onResize === void 0 ? function () {} : _ref$onResize;
  var onResizeFn = useStableCallback(onResize);
  var obs = useMemo(function () {
    var fn = function fn(entries) {
      entries.forEach(function (entry) {
        onResizeFn === null || onResizeFn === void 0 ? void 0 : onResizeFn(entry);
      });
    };
    return new ResizeObserver(debounce(fn, 5));
  }, []);
  useEffect(function () {
    if (el) {
      // 开始监听
      obs === null || obs === void 0 ? void 0 : obs.observe(el);
      return function () {
        obs === null || obs === void 0 ? void 0 : obs.unobserve(el);
        obs === null || obs === void 0 ? void 0 : obs.disconnect();
      };
    }
    return undefined;
  }, [obs, el, deps]);
}